declare type TBootFuntion = (bootLoader?: BootLoader) => void | Promise<void>;
export declare enum EBootState {
    Initial = "initial",
    Booting = "booting",
    Finished = "finished"
}
export declare class BootLoader {
    private state;
    private bootFunctionObjects;
    private afterBootFunctionObjects;
    constructor();
    getBootState(): EBootState;
    isBooting(): boolean;
    hasBooted(): boolean;
    addBootFunction(name: string, fn: TBootFuntion): void;
    onBootReady(name: string, fn: TBootFuntion): void | Promise<void>;
    getReadyPromise(): Promise<void>;
    boot(): Promise<void>;
}
export {};
