"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const crypto_1 = require("crypto");
const path = require("path");
const nodeIdLength = 6;
class EnvironmentBuilder {
    static buildEnvironment(NODE_ENV, namespace) {
        var _a, _b;
        const frameworkVersion = require("../../../package.json").version;
        const applicationRootPath = path.dirname((_b = (_a = require.main) === null || _a === void 0 ? void 0 : _a.filename) !== null && _b !== void 0 ? _b : "");
        const { applicationName, applicationVersion, } = this.getApplicationNameAndVersion(applicationRootPath);
        const nodeId = this.generateNodeId(nodeIdLength);
        return {
            frameworkVersion,
            NODE_ENV,
            name: applicationName,
            path: applicationRootPath,
            version: applicationVersion,
            namespace,
            nodeId,
        };
    }
    static getApplicationNameAndVersion(applicationRootPath) {
        return {
            applicationName: process.env.npm_package_name,
            applicationVersion: process.env.npm_package_version,
        };
    }
    static generateNodeId(length) {
        return crypto_1.randomBytes(20 + length)
            .toString("hex")
            .substr(5, length);
    }
}
exports.default = EnvironmentBuilder;
//# sourceMappingURL=EnvironmentBuilder.js.map