interface IStackFrame {
    filePath: string;
    fullFilePath: string;
    fileName: string;
    lineNumber: number | null;
    columnNumber: number | null;
    isConstructor: boolean | null;
    functionName: string | null;
    typeName: string | null;
    methodName: string | null;
}
interface ILogObject extends IStackFrame {
    loggerName: string;
    date: Date;
    logLevel: number;
    logLevelName: string;
    argumentsArray: (string | object)[];
    stack?: IStackFrame[];
}
export declare class Logger {
    private nodeId;
    private name?;
    private readonly logLevels;
    private readonly logLevelsColors;
    private ignoreStackLevels;
    private doOverwriteConsole;
    private logAsJson;
    constructor(nodeId: string, name?: string | undefined, minLevel?: number);
    silly(...args: any[]): ILogObject;
    trace(...args: any[]): ILogObject;
    debug(...args: any[]): ILogObject;
    info(...args: any[]): ILogObject;
    warn(...args: any[]): ILogObject;
    error(...args: any[]): ILogObject;
    private handleLog;
    private buildLogObject;
    private toStackObjectArray;
    private toStackFrameObject;
    private printPrettyLog;
    private printPrettyStack;
    private printJsonLog;
    private wrapCallSiteOrIgnore;
    private getCallSites;
    private errorToJsonHelper;
    private overwriteConsole;
}
export {};
